%
clear;
clc;

% initial condition
y0 = 1;

% end time
T = 1;

% exact solution
yE = @(t) (1./(t^2+1));

% run convergence test
l = linspace(3,9,7);
h = zeros(size(l));
err_buf = zeros(size(l));

for i=1:size(l,2)
    N = 2^l(i);
    h(i) = T/N;
    
    yN = ...
    err_buf(i) = abs(yN - yE(T));
end

% loglog-plot
loglog(h,err_buf, 'ro-');
xlim([1e-3 2e-1]);
xlabel('h');
ylabel('|y_N - y(T)|');
grid on;

% Konvergenzrate
fit = polyfit(log(h),log(err_buf),1);
fprintf('Empirische Konvergenzrate fur die Taylorreihen Methode: %1.2f\n',fit(1))
